// Please help improve quicktype by enabling anonymous telemetry with:
//
//   $ quicktype --telemetry enable
//
// You can also enable telemetry on any quicktype invocation:
//
//   $ quicktype pokedex.json -o Pokedex.cs --telemetry enable
//
// This helps us improve quicktype by measuring:
//
//   * How many people use quicktype
//   * Which features are popular or unpopular
//   * Performance
//   * Errors
//
// quicktype does not collect:
//
//   * Your filenames or input data
//   * Any personally identifiable information (PII)
//   * Anything not directly related to quicktype's usage
//
// If you don't want to help improve quicktype, you can dismiss this message with:
//
//   $ quicktype --telemetry disable
//
// For a full privacy policy, visit app.quicktype.io/privacy
//
// To parse this JSON data, do
//
//     final glTfProcGen = glTfProcGenFromJson(jsonString);

import 'dart:convert';

GlTfProcGen glTfProcGenFromJson(String str) {
    final jsonData = json.decode(str);
    return GlTfProcGen.fromJson(jsonData);
}

String glTfProcGenToJson(GlTfProcGen data) {
    final dyn = data.toJson();
    return json.encode(dyn);
}

/**
 * The root object for a glTF asset.
 */
class GlTfProcGen {
    List<Accessor> accessors;
    List<Animation> animations;
    Asset asset;
    List<Buffer> buffers;
    List<BufferView> bufferViews;
    List<Camera> cameras;
    Map<String, Map<String, dynamic>> extensions;
    List<String> extensionsRequired;
    List<String> extensionsUsed;
    dynamic extras;
    List<Image> images;
    List<Material> materials;
    List<Mesh> meshes;
    List<Node> nodes;
    List<Sampler> samplers;
    int scene;
    List<Scene> scenes;
    List<Skin> skins;
    List<Texture> textures;

    GlTfProcGen({
        this.accessors,
        this.animations,
        this.asset,
        this.buffers,
        this.bufferViews,
        this.cameras,
        this.extensions,
        this.extensionsRequired,
        this.extensionsUsed,
        this.extras,
        this.images,
        this.materials,
        this.meshes,
        this.nodes,
        this.samplers,
        this.scene,
        this.scenes,
        this.skins,
        this.textures,
    });

    factory GlTfProcGen.fromJson(Map<String, dynamic> json) => new GlTfProcGen(
        accessors: json["accessors"] == null ? null : new List<Accessor>.from(json["accessors"].map((x) => Accessor.fromJson(x))),
        animations: json["animations"] == null ? null : new List<Animation>.from(json["animations"].map((x) => Animation.fromJson(x))),
        asset: Asset.fromJson(json["asset"]),
        buffers: json["buffers"] == null ? null : new List<Buffer>.from(json["buffers"].map((x) => Buffer.fromJson(x))),
        bufferViews: json["bufferViews"] == null ? null : new List<BufferView>.from(json["bufferViews"].map((x) => BufferView.fromJson(x))),
        cameras: json["cameras"] == null ? null : new List<Camera>.from(json["cameras"].map((x) => Camera.fromJson(x))),
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extensionsRequired: json["extensionsRequired"] == null ? null : new List<String>.from(json["extensionsRequired"].map((x) => x)),
        extensionsUsed: json["extensionsUsed"] == null ? null : new List<String>.from(json["extensionsUsed"].map((x) => x)),
        extras: json["extras"],
        images: json["images"] == null ? null : new List<Image>.from(json["images"].map((x) => Image.fromJson(x))),
        materials: json["materials"] == null ? null : new List<Material>.from(json["materials"].map((x) => Material.fromJson(x))),
        meshes: json["meshes"] == null ? null : new List<Mesh>.from(json["meshes"].map((x) => Mesh.fromJson(x))),
        nodes: json["nodes"] == null ? null : new List<Node>.from(json["nodes"].map((x) => Node.fromJson(x))),
        samplers: json["samplers"] == null ? null : new List<Sampler>.from(json["samplers"].map((x) => Sampler.fromJson(x))),
        scene: json["scene"] == null ? null : json["scene"],
        scenes: json["scenes"] == null ? null : new List<Scene>.from(json["scenes"].map((x) => Scene.fromJson(x))),
        skins: json["skins"] == null ? null : new List<Skin>.from(json["skins"].map((x) => Skin.fromJson(x))),
        textures: json["textures"] == null ? null : new List<Texture>.from(json["textures"].map((x) => Texture.fromJson(x))),
    );

    Map<String, dynamic> toJson() => {
        "accessors": accessors == null ? null : new List<dynamic>.from(accessors.map((x) => x.toJson())),
        "animations": animations == null ? null : new List<dynamic>.from(animations.map((x) => x.toJson())),
        "asset": asset.toJson(),
        "buffers": buffers == null ? null : new List<dynamic>.from(buffers.map((x) => x.toJson())),
        "bufferViews": bufferViews == null ? null : new List<dynamic>.from(bufferViews.map((x) => x.toJson())),
        "cameras": cameras == null ? null : new List<dynamic>.from(cameras.map((x) => x.toJson())),
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extensionsRequired": extensionsRequired == null ? null : new List<dynamic>.from(extensionsRequired.map((x) => x)),
        "extensionsUsed": extensionsUsed == null ? null : new List<dynamic>.from(extensionsUsed.map((x) => x)),
        "extras": extras,
        "images": images == null ? null : new List<dynamic>.from(images.map((x) => x.toJson())),
        "materials": materials == null ? null : new List<dynamic>.from(materials.map((x) => x.toJson())),
        "meshes": meshes == null ? null : new List<dynamic>.from(meshes.map((x) => x.toJson())),
        "nodes": nodes == null ? null : new List<dynamic>.from(nodes.map((x) => x.toJson())),
        "samplers": samplers == null ? null : new List<dynamic>.from(samplers.map((x) => x.toJson())),
        "scene": scene == null ? null : scene,
        "scenes": scenes == null ? null : new List<dynamic>.from(scenes.map((x) => x.toJson())),
        "skins": skins == null ? null : new List<dynamic>.from(skins.map((x) => x.toJson())),
        "textures": textures == null ? null : new List<dynamic>.from(textures.map((x) => x.toJson())),
    };
}

/**
 * A typed view into a bufferView.  A bufferView contains raw binary data.  An accessor
 * provides a typed view into a bufferView or a subset of a bufferView similar to how
 * WebGL's `vertexAttribPointer()` defines an attribute in a buffer.
 */
class Accessor {
    int bufferView;
    int byteOffset;
    dynamic componentType;
    int count;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    List<double> max;
    List<double> min;
    String name;
    bool normalized;
    AccessorSparse sparse;
    String type;

    Accessor({
        this.bufferView,
        this.byteOffset,
        this.componentType,
        this.count,
        this.extensions,
        this.extras,
        this.max,
        this.min,
        this.name,
        this.normalized,
        this.sparse,
        this.type,
    });

    factory Accessor.fromJson(Map<String, dynamic> json) => new Accessor(
        bufferView: json["bufferView"] == null ? null : json["bufferView"],
        byteOffset: json["byteOffset"] == null ? null : json["byteOffset"],
        componentType: json["componentType"],
        count: json["count"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        max: json["max"] == null ? null : new List<double>.from(json["max"].map((x) => x.toDouble())),
        min: json["min"] == null ? null : new List<double>.from(json["min"].map((x) => x.toDouble())),
        name: json["name"] == null ? null : json["name"],
        normalized: json["normalized"] == null ? null : json["normalized"],
        sparse: json["sparse"] == null ? null : AccessorSparse.fromJson(json["sparse"]),
        type: json["type"],
    );

    Map<String, dynamic> toJson() => {
        "bufferView": bufferView == null ? null : bufferView,
        "byteOffset": byteOffset == null ? null : byteOffset,
        "componentType": componentType,
        "count": count,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "max": max == null ? null : new List<dynamic>.from(max.map((x) => x)),
        "min": min == null ? null : new List<dynamic>.from(min.map((x) => x)),
        "name": name == null ? null : name,
        "normalized": normalized == null ? null : normalized,
        "sparse": sparse == null ? null : sparse.toJson(),
        "type": type,
    };
}

/**
 * Sparse storage of attributes that deviate from their initialization value.
 */
class AccessorSparse {
    int count;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    AccessorSparseIndices indices;
    AccessorSparseValues values;

    AccessorSparse({
        this.count,
        this.extensions,
        this.extras,
        this.indices,
        this.values,
    });

    factory AccessorSparse.fromJson(Map<String, dynamic> json) => new AccessorSparse(
        count: json["count"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        indices: AccessorSparseIndices.fromJson(json["indices"]),
        values: AccessorSparseValues.fromJson(json["values"]),
    );

    Map<String, dynamic> toJson() => {
        "count": count,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "indices": indices.toJson(),
        "values": values.toJson(),
    };
}

/**
 * Index array of size `count` that points to those accessor attributes that deviate from
 * their initialization value. Indices must strictly increase.
 *
 * Indices of those attributes that deviate from their initialization value.
 */
class AccessorSparseIndices {
    int bufferView;
    int byteOffset;
    dynamic componentType;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;

    AccessorSparseIndices({
        this.bufferView,
        this.byteOffset,
        this.componentType,
        this.extensions,
        this.extras,
    });

    factory AccessorSparseIndices.fromJson(Map<String, dynamic> json) => new AccessorSparseIndices(
        bufferView: json["bufferView"],
        byteOffset: json["byteOffset"] == null ? null : json["byteOffset"],
        componentType: json["componentType"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
    );

    Map<String, dynamic> toJson() => {
        "bufferView": bufferView,
        "byteOffset": byteOffset == null ? null : byteOffset,
        "componentType": componentType,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
    };
}

/**
 * Array of size `count` times number of components, storing the displaced accessor
 * attributes pointed by `indices`. Substituted values must have the same `componentType`
 * and number of components as the base accessor.
 *
 * Array of size `accessor.sparse.count` times number of components storing the displaced
 * accessor attributes pointed by `accessor.sparse.indices`.
 */
class AccessorSparseValues {
    int bufferView;
    int byteOffset;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;

    AccessorSparseValues({
        this.bufferView,
        this.byteOffset,
        this.extensions,
        this.extras,
    });

    factory AccessorSparseValues.fromJson(Map<String, dynamic> json) => new AccessorSparseValues(
        bufferView: json["bufferView"],
        byteOffset: json["byteOffset"] == null ? null : json["byteOffset"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
    );

    Map<String, dynamic> toJson() => {
        "bufferView": bufferView,
        "byteOffset": byteOffset == null ? null : byteOffset,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
    };
}

/**
 * A keyframe animation.
 */
class Animation {
    List<AnimationChannel> channels;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    List<AnimationSampler> samplers;

    Animation({
        this.channels,
        this.extensions,
        this.extras,
        this.name,
        this.samplers,
    });

    factory Animation.fromJson(Map<String, dynamic> json) => new Animation(
        channels: new List<AnimationChannel>.from(json["channels"].map((x) => AnimationChannel.fromJson(x))),
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        samplers: new List<AnimationSampler>.from(json["samplers"].map((x) => AnimationSampler.fromJson(x))),
    );

    Map<String, dynamic> toJson() => {
        "channels": new List<dynamic>.from(channels.map((x) => x.toJson())),
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "samplers": new List<dynamic>.from(samplers.map((x) => x.toJson())),
    };
}

/**
 * Targets an animation's sampler at a node's property.
 */
class AnimationChannel {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int sampler;
    AnimationChannelTarget target;

    AnimationChannel({
        this.extensions,
        this.extras,
        this.sampler,
        this.target,
    });

    factory AnimationChannel.fromJson(Map<String, dynamic> json) => new AnimationChannel(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        sampler: json["sampler"],
        target: AnimationChannelTarget.fromJson(json["target"]),
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "sampler": sampler,
        "target": target.toJson(),
    };
}

/**
 * The index of the node and TRS property to target.
 *
 * The index of the node and TRS property that an animation channel targets.
 */
class AnimationChannelTarget {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int node;
    String path;

    AnimationChannelTarget({
        this.extensions,
        this.extras,
        this.node,
        this.path,
    });

    factory AnimationChannelTarget.fromJson(Map<String, dynamic> json) => new AnimationChannelTarget(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        node: json["node"] == null ? null : json["node"],
        path: json["path"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "node": node == null ? null : node,
        "path": path,
    };
}

/**
 * Combines input and output accessors with an interpolation algorithm to define a keyframe
 * graph (but not its target).
 */
class AnimationSampler {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int input;
    String interpolation;
    int output;

    AnimationSampler({
        this.extensions,
        this.extras,
        this.input,
        this.interpolation,
        this.output,
    });

    factory AnimationSampler.fromJson(Map<String, dynamic> json) => new AnimationSampler(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        input: json["input"],
        interpolation: json["interpolation"] == null ? null : json["interpolation"],
        output: json["output"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "input": input,
        "interpolation": interpolation == null ? null : interpolation,
        "output": output,
    };
}

/**
 * Metadata about the glTF asset.
 */
class Asset {
    String copyright;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String generator;
    String minVersion;
    String version;

    Asset({
        this.copyright,
        this.extensions,
        this.extras,
        this.generator,
        this.minVersion,
        this.version,
    });

    factory Asset.fromJson(Map<String, dynamic> json) => new Asset(
        copyright: json["copyright"] == null ? null : json["copyright"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        generator: json["generator"] == null ? null : json["generator"],
        minVersion: json["minVersion"] == null ? null : json["minVersion"],
        version: json["version"],
    );

    Map<String, dynamic> toJson() => {
        "copyright": copyright == null ? null : copyright,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "generator": generator == null ? null : generator,
        "minVersion": minVersion == null ? null : minVersion,
        "version": version,
    };
}

/**
 * A view into a buffer generally representing a subset of the buffer.
 */
class BufferView {
    int buffer;
    int byteLength;
    int byteOffset;
    int byteStride;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    dynamic target;

    BufferView({
        this.buffer,
        this.byteLength,
        this.byteOffset,
        this.byteStride,
        this.extensions,
        this.extras,
        this.name,
        this.target,
    });

    factory BufferView.fromJson(Map<String, dynamic> json) => new BufferView(
        buffer: json["buffer"],
        byteLength: json["byteLength"],
        byteOffset: json["byteOffset"] == null ? null : json["byteOffset"],
        byteStride: json["byteStride"] == null ? null : json["byteStride"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        target: json["target"],
    );

    Map<String, dynamic> toJson() => {
        "buffer": buffer,
        "byteLength": byteLength,
        "byteOffset": byteOffset == null ? null : byteOffset,
        "byteStride": byteStride == null ? null : byteStride,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "target": target,
    };
}

/**
 * A buffer points to binary geometry, animation, or skins.
 */
class Buffer {
    int byteLength;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    String uri;

    Buffer({
        this.byteLength,
        this.extensions,
        this.extras,
        this.name,
        this.uri,
    });

    factory Buffer.fromJson(Map<String, dynamic> json) => new Buffer(
        byteLength: json["byteLength"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        uri: json["uri"] == null ? null : json["uri"],
    );

    Map<String, dynamic> toJson() => {
        "byteLength": byteLength,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "uri": uri == null ? null : uri,
    };
}

/**
 * A camera's projection.  A node can reference a camera to apply a transform to place the
 * camera in the scene.
 */
class Camera {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    CameraOrthographic orthographic;
    CameraPerspective perspective;
    String type;

    Camera({
        this.extensions,
        this.extras,
        this.name,
        this.orthographic,
        this.perspective,
        this.type,
    });

    factory Camera.fromJson(Map<String, dynamic> json) => new Camera(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        orthographic: json["orthographic"] == null ? null : CameraOrthographic.fromJson(json["orthographic"]),
        perspective: json["perspective"] == null ? null : CameraPerspective.fromJson(json["perspective"]),
        type: json["type"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "orthographic": orthographic == null ? null : orthographic.toJson(),
        "perspective": perspective == null ? null : perspective.toJson(),
        "type": type,
    };
}

/**
 * An orthographic camera containing properties to create an orthographic projection matrix.
 */
class CameraOrthographic {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    double xmag;
    double ymag;
    double zfar;
    double znear;

    CameraOrthographic({
        this.extensions,
        this.extras,
        this.xmag,
        this.ymag,
        this.zfar,
        this.znear,
    });

    factory CameraOrthographic.fromJson(Map<String, dynamic> json) => new CameraOrthographic(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        xmag: json["xmag"].toDouble(),
        ymag: json["ymag"].toDouble(),
        zfar: json["zfar"].toDouble(),
        znear: json["znear"].toDouble(),
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "xmag": xmag,
        "ymag": ymag,
        "zfar": zfar,
        "znear": znear,
    };
}

/**
 * A perspective camera containing properties to create a perspective projection matrix.
 */
class CameraPerspective {
    double aspectRatio;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    double yfov;
    double zfar;
    double znear;

    CameraPerspective({
        this.aspectRatio,
        this.extensions,
        this.extras,
        this.yfov,
        this.zfar,
        this.znear,
    });

    factory CameraPerspective.fromJson(Map<String, dynamic> json) => new CameraPerspective(
        aspectRatio: json["aspectRatio"] == null ? null : json["aspectRatio"].toDouble(),
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        yfov: json["yfov"].toDouble(),
        zfar: json["zfar"] == null ? null : json["zfar"].toDouble(),
        znear: json["znear"].toDouble(),
    );

    Map<String, dynamic> toJson() => {
        "aspectRatio": aspectRatio == null ? null : aspectRatio,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "yfov": yfov,
        "zfar": zfar == null ? null : zfar,
        "znear": znear,
    };
}

/**
 * Image data used to create a texture. Image can be referenced by URI or `bufferView`
 * index. `mimeType` is required in the latter case.
 */
class Image {
    int bufferView;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String mimeType;
    String name;
    String uri;

    Image({
        this.bufferView,
        this.extensions,
        this.extras,
        this.mimeType,
        this.name,
        this.uri,
    });

    factory Image.fromJson(Map<String, dynamic> json) => new Image(
        bufferView: json["bufferView"] == null ? null : json["bufferView"],
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        mimeType: json["mimeType"] == null ? null : json["mimeType"],
        name: json["name"] == null ? null : json["name"],
        uri: json["uri"] == null ? null : json["uri"],
    );

    Map<String, dynamic> toJson() => {
        "bufferView": bufferView == null ? null : bufferView,
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "mimeType": mimeType == null ? null : mimeType,
        "name": name == null ? null : name,
        "uri": uri == null ? null : uri,
    };
}

/**
 * The material appearance of a primitive.
 */
class Material {
    double alphaCutoff;
    String alphaMode;
    bool doubleSided;
    List<double> emissiveFactor;
    TextureInfo emissiveTexture;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    MaterialNormalTextureInfoClass normalTexture;
    MaterialOcclusionTextureInfoClass occlusionTexture;
    MaterialPbrMetallicRoughness pbrMetallicRoughness;

    Material({
        this.alphaCutoff,
        this.alphaMode,
        this.doubleSided,
        this.emissiveFactor,
        this.emissiveTexture,
        this.extensions,
        this.extras,
        this.name,
        this.normalTexture,
        this.occlusionTexture,
        this.pbrMetallicRoughness,
    });

    factory Material.fromJson(Map<String, dynamic> json) => new Material(
        alphaCutoff: json["alphaCutoff"] == null ? null : json["alphaCutoff"].toDouble(),
        alphaMode: json["alphaMode"] == null ? null : json["alphaMode"],
        doubleSided: json["doubleSided"] == null ? null : json["doubleSided"],
        emissiveFactor: json["emissiveFactor"] == null ? null : new List<double>.from(json["emissiveFactor"].map((x) => x.toDouble())),
        emissiveTexture: json["emissiveTexture"] == null ? null : TextureInfo.fromJson(json["emissiveTexture"]),
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        normalTexture: json["normalTexture"] == null ? null : MaterialNormalTextureInfoClass.fromJson(json["normalTexture"]),
        occlusionTexture: json["occlusionTexture"] == null ? null : MaterialOcclusionTextureInfoClass.fromJson(json["occlusionTexture"]),
        pbrMetallicRoughness: json["pbrMetallicRoughness"] == null ? null : MaterialPbrMetallicRoughness.fromJson(json["pbrMetallicRoughness"]),
    );

    Map<String, dynamic> toJson() => {
        "alphaCutoff": alphaCutoff == null ? null : alphaCutoff,
        "alphaMode": alphaMode == null ? null : alphaMode,
        "doubleSided": doubleSided == null ? null : doubleSided,
        "emissiveFactor": emissiveFactor == null ? null : new List<dynamic>.from(emissiveFactor.map((x) => x)),
        "emissiveTexture": emissiveTexture == null ? null : emissiveTexture.toJson(),
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "normalTexture": normalTexture == null ? null : normalTexture.toJson(),
        "occlusionTexture": occlusionTexture == null ? null : occlusionTexture.toJson(),
        "pbrMetallicRoughness": pbrMetallicRoughness == null ? null : pbrMetallicRoughness.toJson(),
    };
}

/**
 * The emissive map texture.
 *
 * The base color texture.
 *
 * The metallic-roughness texture.
 *
 * Reference to a texture.
 */
class TextureInfo {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int index;
    int texCoord;

    TextureInfo({
        this.extensions,
        this.extras,
        this.index,
        this.texCoord,
    });

    factory TextureInfo.fromJson(Map<String, dynamic> json) => new TextureInfo(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        index: json["index"],
        texCoord: json["texCoord"] == null ? null : json["texCoord"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "index": index,
        "texCoord": texCoord == null ? null : texCoord,
    };
}

/**
 * The normal map texture.
 *
 * Reference to a texture.
 */
class MaterialNormalTextureInfoClass {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int index;
    double scale;
    int texCoord;

    MaterialNormalTextureInfoClass({
        this.extensions,
        this.extras,
        this.index,
        this.scale,
        this.texCoord,
    });

    factory MaterialNormalTextureInfoClass.fromJson(Map<String, dynamic> json) => new MaterialNormalTextureInfoClass(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        index: json["index"],
        scale: json["scale"] == null ? null : json["scale"].toDouble(),
        texCoord: json["texCoord"] == null ? null : json["texCoord"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "index": index,
        "scale": scale == null ? null : scale,
        "texCoord": texCoord == null ? null : texCoord,
    };
}

/**
 * The occlusion map texture.
 *
 * Reference to a texture.
 */
class MaterialOcclusionTextureInfoClass {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int index;
    double strength;
    int texCoord;

    MaterialOcclusionTextureInfoClass({
        this.extensions,
        this.extras,
        this.index,
        this.strength,
        this.texCoord,
    });

    factory MaterialOcclusionTextureInfoClass.fromJson(Map<String, dynamic> json) => new MaterialOcclusionTextureInfoClass(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        index: json["index"],
        strength: json["strength"] == null ? null : json["strength"].toDouble(),
        texCoord: json["texCoord"] == null ? null : json["texCoord"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "index": index,
        "strength": strength == null ? null : strength,
        "texCoord": texCoord == null ? null : texCoord,
    };
}

/**
 * A set of parameter values that are used to define the metallic-roughness material model
 * from Physically-Based Rendering (PBR) methodology. When not specified, all the default
 * values of `pbrMetallicRoughness` apply.
 *
 * A set of parameter values that are used to define the metallic-roughness material model
 * from Physically-Based Rendering (PBR) methodology.
 */
class MaterialPbrMetallicRoughness {
    List<double> baseColorFactor;
    TextureInfo baseColorTexture;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    double metallicFactor;
    TextureInfo metallicRoughnessTexture;
    double roughnessFactor;

    MaterialPbrMetallicRoughness({
        this.baseColorFactor,
        this.baseColorTexture,
        this.extensions,
        this.extras,
        this.metallicFactor,
        this.metallicRoughnessTexture,
        this.roughnessFactor,
    });

    factory MaterialPbrMetallicRoughness.fromJson(Map<String, dynamic> json) => new MaterialPbrMetallicRoughness(
        baseColorFactor: json["baseColorFactor"] == null ? null : new List<double>.from(json["baseColorFactor"].map((x) => x.toDouble())),
        baseColorTexture: json["baseColorTexture"] == null ? null : TextureInfo.fromJson(json["baseColorTexture"]),
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        metallicFactor: json["metallicFactor"] == null ? null : json["metallicFactor"].toDouble(),
        metallicRoughnessTexture: json["metallicRoughnessTexture"] == null ? null : TextureInfo.fromJson(json["metallicRoughnessTexture"]),
        roughnessFactor: json["roughnessFactor"] == null ? null : json["roughnessFactor"].toDouble(),
    );

    Map<String, dynamic> toJson() => {
        "baseColorFactor": baseColorFactor == null ? null : new List<dynamic>.from(baseColorFactor.map((x) => x)),
        "baseColorTexture": baseColorTexture == null ? null : baseColorTexture.toJson(),
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "metallicFactor": metallicFactor == null ? null : metallicFactor,
        "metallicRoughnessTexture": metallicRoughnessTexture == null ? null : metallicRoughnessTexture.toJson(),
        "roughnessFactor": roughnessFactor == null ? null : roughnessFactor,
    };
}

/**
 * A set of primitives to be rendered.  A node can contain one mesh.  A node's transform
 * places the mesh in the scene.
 */
class Mesh {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    List<MeshPrimitive> primitives;
    List<double> weights;

    Mesh({
        this.extensions,
        this.extras,
        this.name,
        this.primitives,
        this.weights,
    });

    factory Mesh.fromJson(Map<String, dynamic> json) => new Mesh(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        primitives: new List<MeshPrimitive>.from(json["primitives"].map((x) => MeshPrimitive.fromJson(x))),
        weights: json["weights"] == null ? null : new List<double>.from(json["weights"].map((x) => x.toDouble())),
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "primitives": new List<dynamic>.from(primitives.map((x) => x.toJson())),
        "weights": weights == null ? null : new List<dynamic>.from(weights.map((x) => x)),
    };
}

/**
 * Geometry to be rendered with the given material.
 */
class MeshPrimitive {
    Map<String, int> attributes;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int indices;
    int material;
    dynamic mode;
    List<Map<String, int>> targets;

    MeshPrimitive({
        this.attributes,
        this.extensions,
        this.extras,
        this.indices,
        this.material,
        this.mode,
        this.targets,
    });

    factory MeshPrimitive.fromJson(Map<String, dynamic> json) => new MeshPrimitive(
        attributes: new Map.from(json["attributes"]).map((k, v) => new MapEntry<String, int>(k, v)),
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        indices: json["indices"] == null ? null : json["indices"],
        material: json["material"] == null ? null : json["material"],
        mode: json["mode"],
        targets: json["targets"] == null ? null : new List<Map<String, int>>.from(json["targets"].map((x) => new Map.from(x).map((k, v) => new MapEntry<String, int>(k, v)))),
    );

    Map<String, dynamic> toJson() => {
        "attributes": new Map.from(attributes).map((k, v) => new MapEntry<String, dynamic>(k, v)),
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "indices": indices == null ? null : indices,
        "material": material == null ? null : material,
        "mode": mode,
        "targets": targets == null ? null : new List<dynamic>.from(targets.map((x) => new Map.from(x).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
    };
}

/**
 * A node in the node hierarchy.  When the node contains `skin`, all `mesh.primitives` must
 * contain `JOINTS_0` and `WEIGHTS_0` attributes.  A node can have either a `matrix` or any
 * combination of `translation`/`rotation`/`scale` (TRS) properties. TRS properties are
 * converted to matrices and postmultiplied in the `T * R * S` order to compose the
 * transformation matrix; first the scale is applied to the vertices, then the rotation, and
 * then the translation. If none are provided, the transform is the identity. When a node is
 * targeted for animation (referenced by an animation.channel.target), only TRS properties
 * may be present; `matrix` will not be present.
 */
class Node {
    int camera;
    List<int> children;
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    List<double> matrix;
    int mesh;
    String name;
    List<double> rotation;
    List<double> scale;
    int skin;
    List<double> translation;
    List<double> weights;

    Node({
        this.camera,
        this.children,
        this.extensions,
        this.extras,
        this.matrix,
        this.mesh,
        this.name,
        this.rotation,
        this.scale,
        this.skin,
        this.translation,
        this.weights,
    });

    factory Node.fromJson(Map<String, dynamic> json) => new Node(
        camera: json["camera"] == null ? null : json["camera"],
        children: json["children"] == null ? null : new List<int>.from(json["children"].map((x) => x)),
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        matrix: json["matrix"] == null ? null : new List<double>.from(json["matrix"].map((x) => x.toDouble())),
        mesh: json["mesh"] == null ? null : json["mesh"],
        name: json["name"] == null ? null : json["name"],
        rotation: json["rotation"] == null ? null : new List<double>.from(json["rotation"].map((x) => x.toDouble())),
        scale: json["scale"] == null ? null : new List<double>.from(json["scale"].map((x) => x.toDouble())),
        skin: json["skin"] == null ? null : json["skin"],
        translation: json["translation"] == null ? null : new List<double>.from(json["translation"].map((x) => x.toDouble())),
        weights: json["weights"] == null ? null : new List<double>.from(json["weights"].map((x) => x.toDouble())),
    );

    Map<String, dynamic> toJson() => {
        "camera": camera == null ? null : camera,
        "children": children == null ? null : new List<dynamic>.from(children.map((x) => x)),
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "matrix": matrix == null ? null : new List<dynamic>.from(matrix.map((x) => x)),
        "mesh": mesh == null ? null : mesh,
        "name": name == null ? null : name,
        "rotation": rotation == null ? null : new List<dynamic>.from(rotation.map((x) => x)),
        "scale": scale == null ? null : new List<dynamic>.from(scale.map((x) => x)),
        "skin": skin == null ? null : skin,
        "translation": translation == null ? null : new List<dynamic>.from(translation.map((x) => x)),
        "weights": weights == null ? null : new List<dynamic>.from(weights.map((x) => x)),
    };
}

/**
 * Texture sampler properties for filtering and wrapping modes.
 */
class Sampler {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    dynamic magFilter;
    dynamic minFilter;
    String name;
    dynamic wrapS;
    dynamic wrapT;

    Sampler({
        this.extensions,
        this.extras,
        this.magFilter,
        this.minFilter,
        this.name,
        this.wrapS,
        this.wrapT,
    });

    factory Sampler.fromJson(Map<String, dynamic> json) => new Sampler(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        magFilter: json["magFilter"],
        minFilter: json["minFilter"],
        name: json["name"] == null ? null : json["name"],
        wrapS: json["wrapS"],
        wrapT: json["wrapT"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "magFilter": magFilter,
        "minFilter": minFilter,
        "name": name == null ? null : name,
        "wrapS": wrapS,
        "wrapT": wrapT,
    };
}

/**
 * The root nodes of a scene.
 */
class Scene {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    List<int> nodes;

    Scene({
        this.extensions,
        this.extras,
        this.name,
        this.nodes,
    });

    factory Scene.fromJson(Map<String, dynamic> json) => new Scene(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        nodes: json["nodes"] == null ? null : new List<int>.from(json["nodes"].map((x) => x)),
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "nodes": nodes == null ? null : new List<dynamic>.from(nodes.map((x) => x)),
    };
}

/**
 * Joints and matrices defining a skin.
 */
class Skin {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    int inverseBindMatrices;
    List<int> joints;
    String name;
    int skeleton;

    Skin({
        this.extensions,
        this.extras,
        this.inverseBindMatrices,
        this.joints,
        this.name,
        this.skeleton,
    });

    factory Skin.fromJson(Map<String, dynamic> json) => new Skin(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        inverseBindMatrices: json["inverseBindMatrices"] == null ? null : json["inverseBindMatrices"],
        joints: new List<int>.from(json["joints"].map((x) => x)),
        name: json["name"] == null ? null : json["name"],
        skeleton: json["skeleton"] == null ? null : json["skeleton"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "inverseBindMatrices": inverseBindMatrices == null ? null : inverseBindMatrices,
        "joints": new List<dynamic>.from(joints.map((x) => x)),
        "name": name == null ? null : name,
        "skeleton": skeleton == null ? null : skeleton,
    };
}

/**
 * A texture and its sampler.
 */
class Texture {
    Map<String, Map<String, dynamic>> extensions;
    dynamic extras;
    String name;
    int sampler;
    int source;

    Texture({
        this.extensions,
        this.extras,
        this.name,
        this.sampler,
        this.source,
    });

    factory Texture.fromJson(Map<String, dynamic> json) => new Texture(
        extensions: json["extensions"] == null ? null : new Map.from(json["extensions"]).map((k, v) => new MapEntry<String, Map<String, dynamic>>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        extras: json["extras"],
        name: json["name"] == null ? null : json["name"],
        sampler: json["sampler"] == null ? null : json["sampler"],
        source: json["source"] == null ? null : json["source"],
    );

    Map<String, dynamic> toJson() => {
        "extensions": extensions == null ? null : new Map.from(extensions).map((k, v) => new MapEntry<String, dynamic>(k, new Map.from(v).map((k, v) => new MapEntry<String, dynamic>(k, v)))),
        "extras": extras,
        "name": name == null ? null : name,
        "sampler": sampler == null ? null : sampler,
        "source": source == null ? null : source,
    };
}
