import 'package:vector_math/vector_math.dart';
import 'util.dart';

double /*shade*/ SphereRay(Vector3 vCamera, Vector3 vSphere, Vector3 vScreen) {
  Vector3 vCast = vScreen - vCamera;
  double scale = intersectRaySphere(vCamera, vCast, vSphere, 5.0);
  if (double.infinity != scale) {
    Vector3 intersect = vCast;
    intersect.scale(scale);
    intersect.add(vCamera);
    Vector3 normal = intersect - vSphere;
    normal.normalize();
    return normal.z.abs();
  } else {
    return 0.0;
  }
}

Vector3 SphereRayNormal(
    Vector3 vCamera, Vector3 vSphere, Vector3 vScreen
    ) {
  Vector3 vCast = vScreen - vCamera;
  double scale = intersectRaySphere(vCamera, vCast, vSphere, 5.0);
  if (double.infinity != scale) {
    Vector3 intersect = vCast.clone();
    intersect.scale(scale);
    intersect.add(vCamera);
    Vector3 normal = intersect - vSphere;
    normal.normalize();
    return normal;
  } else {
    return new Vector3(0.0, 0.0, -1.0);
  }
}

int mapRange255(double val) {
  assert(val >= -1.0);
  assert(val <= 1.0);
  val += 1.0;
  val /= 2.0;
  return (val * 255).toInt();
}

int color(Vector4 v) {
  int color = mapRange255(v[0]);
  for(int i = 1; i < 4; i++) {
    color <<= 8;
    color |= mapRange255(v[i]);
  }
  return color;
}

