import 'package:vector_math/vector_math.dart';
import 'cell_noise.dart';

class worley_sample {
  String _id;
  String get id { return _id; }
  final Vector3 cell_value = new Vector3.zero();
  final Vector3 cell_location = new Vector3.zero();
  final Vector3 cell_neighbor_offset = new Vector3.zero();
  final double distance;
  worley_sample(
      Vector3 cell_location,
      Vector3 cell_neighbor_offset,
      Vector3 cell_value,
      this.distance
      ) {
    cell_location.copyInto(this.cell_location);
    cell_neighbor_offset.copyInto(this.cell_neighbor_offset);
    cell_value.copyInto(this.cell_value);
    _id = cell_value.toString();
  }
}

List<worley_sample> worley1(double x, double y, double z, double p) {
  final distance = new Vector3.zero();

  const limit = 1.0;

  final v0 = new Vector3.zero();
  v0.setValues(x, y, z);
  var samples = new List<worley_sample>();

  for(double offset_x = -limit; offset_x <= limit; offset_x += 1.0)
    for(double offset_y = -limit; offset_y <= limit; offset_y += 1.0)
      for(double offset_z = -limit; offset_z <= limit; offset_z += 1.0) {
        var v1 = PCellNoise3p(x + offset_x, y + offset_y, z + offset_z, p);
        distance.setValues(x.floor() + offset_x, y.floor() + offset_y, z.floor() + offset_z);
        distance.add(v1);
        distance.sub(v0);
        var cell_location = new Vector3(
            (x % p).floor().toDouble(),
            (y % p).floor().toDouble(),
            (z % p).floor().toDouble());
        var cell_neighbor_offset = new Vector3(
          offset_x, offset_y, offset_z
        );
        samples.add(new worley_sample(cell_location, cell_neighbor_offset, v1, distance.length));
      }
  samples.sort((s0, s1) => s0.distance.compareTo(s1.distance));
  return samples;
}
