import 'dart:math' as math;
import 'package:vector_math/vector_math.dart';

class quantize {
  int _scale = 0;
  final int _bitfield_size = 1 << 20;
  quantize([int fractionBitCount = 8]) {
    if(fractionBitCount > 16)
      throw new Exception("bit count cannot exceed 16");
    this._scale = math.pow(2, fractionBitCount);
  }
  int encode(double val) {
    if(val < 0)
      throw new Exception("cannot quantize negative values");
    val *= this._scale;
    return val.toInt();
  }
  double decode(int val) {
    double tmp = val.toDouble();
    tmp /= this._scale;
    return tmp;
  }
  int encodeVector3BigInt(Vector3 vIn) {
    int tmp = this.encode(vIn.x);
    tmp *= this._bitfield_size;
    tmp += this.encode(vIn.y);
    tmp *= this._bitfield_size;
    tmp += this.encode(vIn.z);
    return tmp;
  }
  void decodeVector3BigInt(int vIn, Vector3 vOut) {
    if(null == vOut)
      throw new Exception("null == vOut");
    int z = vIn % this._bitfield_size;
    vIn ~/= this._bitfield_size;
    int y = vIn % this._bitfield_size;
    vIn ~/= this._bitfield_size;
    int x = vIn % this._bitfield_size;
    vOut.x = this.decode(x);
    vOut.y = this.decode(y);
    vOut.z = this.decode(z);
  }
}
