import 'package:vector_math/vector_math.dart';
import 'mesh_texture.dart';
import 'voxel_quad.dart';

class mesh_texture_buckets {
  final int normal_index_modulo;
  final voxel_quad _voxel_quad;
  final _buckets = new Map<String, mesh_texture>();
  mesh_texture_buckets(int normal_index_modulo)
      : this.normal_index_modulo = normal_index_modulo,
        _voxel_quad = new voxel_quad(normal_index_modulo) {}
  void add(Iterable<Vector3> quads) {
    while(_voxel_quad.load(quads)) {
      String texture_bucket_key = _voxel_quad.texture_bucket_key;
      if(!_buckets.containsKey(texture_bucket_key))
        _buckets[texture_bucket_key] = new mesh_texture(texture_bucket_key);
      var mesh_texture_ = _buckets[texture_bucket_key];
      mesh_texture_.append(_voxel_quad);
    }
  }
}
