import 'package:vector_math/vector_math.dart';
import 'voxel_db.dart';
import 'cube_march_quad.dart';

class voxel_quad_extractor {
  final voxel_db _voxel_db;
  cube_march_quad _cube_march_quad;
  voxel_quad_extractor(voxel_db voxel_db, double surface_temperature)
      : _voxel_db = voxel_db {
    _cube_march_quad = new cube_march_quad(surface_temperature);
  }

  static final Vector3 _iter = new Vector3.zero();

  Iterable<Vector3> iterate_quads() sync* {
    for (var voxel_walker_ in _voxel_db.iterator_voxels(false)) {
      for(var v in _cube_march_quad.get_surface_quads(voxel_walker_)) {
        v.copyInto(_iter);
        _iter.scale(voxel_walker_.voxels.scale);
        _iter.add(voxel_walker_.world_position);
        yield _iter;
      }
    }
  }
}
