import 'package:vector_math/vector_math.dart';
import 'voxel_array.dart';

class voxel_walker {
  voxel_array voxels;
  int x;
  int y;
  int z;
  void set(double val) {
    voxels.set(x, y, z, val);
  }

  double get() {
    return voxels.get(x, y, z);
  }

  double get_relative(int xr, int yr, int zr) {
    return voxels.get(x + xr, y + yr, z + zr);
  }

  void scale(double multiplier) {
    double val = voxels.get(x, y, z);
    val *= multiplier;
    set(val);
  }

  final Vector3 _world_position = new Vector3.zero();
  Vector3 get world_position {
    voxels.get_world_pos(x, y, z, _world_position);
    return _world_position;
  }
}
